/*
 * Libraries to link to:
 * libcmt.lib kernel32.lib advapi.lib shell32.lib
*/

#ifndef _SERVICE_H
#define _SERVICE_H


#ifdef __cplusplus
extern "C" {
#endif

//////////////////////////////////////////////////////////////////////////////
//// todo: change to desired strings
////
// name of the executable
#define SZAPPNAME            szappname
// internal name of the service
#define SZSERVICENAME        szservicename
// displayed name of the service
#define SZSERVICEDISPLAYNAME szdisplayname
// list of service dependencies - "dep1\0dep2\0\0"
//#define SZDEPENDENCIES "dep1\0dep2\0\0"
#define SZDEPENDENCIES       szdependencies

int stopport;
BOOL bDebug;
BOOL bCommandLine;
BOOL bCommandLineDebug;
BOOL bService;
BOOL useConsoleHandler;
LPTSTR stopClass;
LPTSTR stopMethod;
LPTSTR stopSignature;

LPTSTR pauseClass;
LPTSTR pauseMethod;
LPTSTR pauseSignature;

LPTSTR contClass;
LPTSTR contMethod;
LPTSTR contSignature;

LPTSTR premainClass;
LPTSTR premainMethod;
LPTSTR premainSignature;

LPTSTR systemOut;
LPTSTR systemErr;

BOOL systemOutAppend;
BOOL systemErrAppend;

// 0.99d - 19.02.2003 Urs Bloechlinger
BOOL stdOutAppend;
BOOL stdErrAppend;

BOOL bPaused;
//p0.99
int	exceptionErrorCode; 
int startdelay;
LPTSTR onExitError;
BOOL breportservicestoppedonmainthreadexit;

// this event is signalled when the
// service should end
//
HANDLE  hServerStopEvent;


//////////////////////////////////////////////////////////////////////////////


//////////////////////////////////////////////////////////////////////////////
VOID ServiceStart(DWORD dwArgc, LPTSTR *lpszArgv);
VOID ServiceStop();
VOID ServicePause();
VOID ServiceContinue();
void storeParams();
int parseParams();
void getParams();
void init();
void logf( LPTSTR );
void logfd( long );
void getIniFile();
void cleanup();
void prepare();
void getIniDir( LPTSTR szPath , LPTSTR szDrive, LPTSTR szDir);
int JSLGetProfileString( LPTSTR section, LPTSTR name, LPTSTR _default, LPTSTR buffer, int bsize, LPTSTR path );
void AddToMessageLog(LPTSTR lpszMsg);
BOOL WINAPI ControlHandler ( DWORD dwCtrlType );
//////////////////////////////////////////////////////////////////////////////



//////////////////////////////////////////////////////////////////////////////
//// The following are procedures which
//// may be useful to call within the above procedures,
//// but require no implementation by the user.
//// They are implemented in service.c

//
//  FUNCTION: ReportStatusToSCMgr()
//
//  PURPOSE: Sets the current status of the service and
//           reports it to the Service Control Manager
//
//  PARAMETERS:
//    dwCurrentState - the state of the service
//    dwWin32ExitCode - error code to report
//    dwWaitHint - worst case estimate to next checkpoint
//
//  RETURN VALUE:
//    TRUE  - success 
//    FALSE - failure
//
BOOL ReportStatusToSCMgr(DWORD dwCurrentState, DWORD dwWin32ExitCode, DWORD dwWaitHint);

//
//  FUNCTION: AddToMessageLog(LPTSTR lpszMsg)
//
//  PURPOSE: Allows any thread to log an error message
//
//  PARAMETERS:
//    lpszMsg - text for message
//
//  RETURN VALUE:
//    none
//
void AddToMessageLog(LPTSTR lpszMsg);
//////////////////////////////////////////////////////////////////////////////


#ifdef __cplusplus
}
#endif

#endif
